"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.validarCodigoBarras = void 0;
function validarCodigoBarras(codigoDeBarras) {
    if (codigoDeBarras.length != 44) {
        var errorMessage = ['Erro na geração do código de barras.',
            'Número de dígitos diferente de 44.',
            'Verifique se todos os dados foram preenchidos corretamente.',
            'Tamanho encontrado: ' + codigoDeBarras.length,
            'Valor encontrado: ' + codigoDeBarras
        ].join(' ');
        throw new Error(errorMessage);
    }
}
exports.validarCodigoBarras = validarCodigoBarras;
//# sourceMappingURL=valida-codigo-barras.js.map