"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Endereco = void 0;
var formatacoesUtils_1 = require("./formatacoesUtils");
var Endereco = /** @class */ (function () {
    function Endereco() {
    }
    Endereco.novoEndereco = function () {
        return new Endereco();
    };
    Endereco.prototype.getLogradouro = function () {
        return this._logradouro || '';
    };
    Endereco.prototype.comLogradouro = function (_logradouro) {
        this._logradouro = _logradouro;
        return this;
    };
    Endereco.prototype.getBairro = function () {
        return this._bairro || '';
    };
    Endereco.prototype.comBairro = function (_bairro) {
        this._bairro = _bairro;
        return this;
    };
    Endereco.prototype.getCep = function () {
        return this._cep || '';
    };
    Endereco.prototype.getCepFormatado = function () {
        return formatacoesUtils_1.FormatacoesUtils.cep(this.getCep());
    };
    Endereco.prototype.comCep = function (_cep) {
        this._cep = _cep;
        return this;
    };
    Endereco.prototype.getCidade = function () {
        return this._cidade || '';
    };
    Endereco.prototype.comCidade = function (_cidade) {
        this._cidade = _cidade;
        return this;
    };
    Endereco.prototype.getUf = function () {
        return this._uf || '';
    };
    Endereco.prototype.comUf = function (_uf) {
        this._uf = _uf;
        return this;
    };
    Endereco.prototype.getPrimeiraLinha = function () {
        return this.primeiraLinha;
    };
    Endereco.prototype.getSegundaLinha = function () {
        return this.segundaLinha;
    };
    Endereco.prototype.getEnderecoCompleto = function () {
        var enderecoCompleto = [];
        // tslint:disable-next-line:no-unused-expression
        this.getLogradouro() && enderecoCompleto.push(this.getLogradouro());
        // tslint:disable-next-line:no-unused-expression
        this.getBairro() && enderecoCompleto.push(this.getBairro());
        // tslint:disable-next-line:no-unused-expression
        this.getCep() && enderecoCompleto.push(this.getCepFormatado());
        // tslint:disable-next-line:no-unused-expression
        this.getCidade() && enderecoCompleto.push(this.getCidade());
        // tslint:disable-next-line:no-unused-expression
        this.getUf() && enderecoCompleto.push(this.getUf());
        return enderecoCompleto.join(' ');
    };
    return Endereco;
}());
exports.Endereco = Endereco;
//# sourceMappingURL=endereco.js.map