"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VariableHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var rxjs_1 = require("rxjs");
var VariableHook = /** @class */ (function (_super) {
    __extends(VariableHook, _super);
    function VariableHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    VariableHook.prototype.get = function (input) {
        var variableContext = this.context.getData('flowContext').variableContext;
        var value = this.reduceToValue(input.object.variable, variableContext);
        var output = new nick_process_commons_1.NickProcessArtfact();
        output.kind = nick_data_commons_1.ArtfactKind.ANY;
        output.object = value;
        return (0, rxjs_1.of)(output);
    };
    VariableHook.prototype.set = function (input) {
        var variableContext = this.context.getData('flowContext').variableContext;
        var property = input.object.variable.split('.').pop();
        var properties = input.object.variable.split('.');
        properties.pop();
        var parent = properties.reduce(function (o, i, index) {
            if (o && (properties.length - 1) > index && o[i] instanceof Map) {
                // @ts-ignore
                return Object.fromEntries(o[i].entries());
            }
            return o ? o[i] : o;
        }, variableContext);
        if (!parent)
            parent = {};
        parent[property] = input.object.data;
        var output = new nick_process_commons_1.NickProcessArtfact();
        output.kind = nick_data_commons_1.ArtfactKind.ANY;
        output.object = parent[property];
        return (0, rxjs_1.of)(output);
    };
    VariableHook.prototype.reduceToValue = function (property, context) {
        var _value;
        if (!property.length)
            _value = context;
        else {
            var properties_1 = property.split('.');
            _value = properties_1.reduce(function (o, i, index) {
                if (o && (properties_1.length - 1) > index && o[i] instanceof Map) {
                    return Object.fromEntries(o[i].entries());
                }
                return (o ? o[i] : o);
            }, context);
        }
        return _value;
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('7ee7b6fa-2d41-42bb-b836-9e4a12a162e8')
    ], VariableHook.prototype, "get", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('85194d43-72b6-4f82-811e-fffef40184d3')
    ], VariableHook.prototype, "set", null);
    VariableHook = __decorate([
        (0, nick_process_commons_1.HookClass)('variable')
    ], VariableHook);
    return VariableHook;
}(nick_process_commons_1.BaseHook));
exports.VariableHook = VariableHook;
//# sourceMappingURL=variable.hook.js.map