"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ErrorHook = void 0;
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var ErrorHook = /** @class */ (function (_super) {
    __extends(ErrorHook, _super);
    function ErrorHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ErrorHook.prototype.throw = function (inputArtifact) {
        return (0, rxjs_1.of)(inputArtifact)
            .pipe((0, operators_1.concatMap)(function () {
            var _a;
            var err;
            if (inputArtifact.object.hasOwnProperty('message'))
                err = new Error(inputArtifact.object.message);
            else
                err = new Error(inputArtifact.object.data);
            err.__statusCode = (_a = inputArtifact.object.config) === null || _a === void 0 ? void 0 : _a.statusCode;
            err.__extraData = inputArtifact.object.data;
            err.__flunaError = true;
            throw err;
        }));
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('f4dcc6e7-e881-45c5-9219-199af40af7c2')
    ], ErrorHook.prototype, "throw", null);
    ErrorHook = __decorate([
        (0, nick_process_commons_1.HookClass)('error')
    ], ErrorHook);
    return ErrorHook;
}(nick_process_commons_1.BaseHook));
exports.ErrorHook = ErrorHook;
//# sourceMappingURL=error.hook.js.map