"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EventIntervalHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var EventIntervalHook = /** @class */ (function () {
    function EventIntervalHook() {
    }
    EventIntervalHook.prototype.interval = function (args) {
        return (0, rxjs_1.interval)(args.object.config.delay)
            .pipe((0, operators_1.map)(function (index) {
            var artifact = new nick_process_commons_1.NickProcessArtfact();
            artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            artifact.object = index;
            return artifact;
        }));
    };
    EventIntervalHook.prototype.delay = function (args) {
        var artifact = new nick_process_commons_1.NickProcessArtfact();
        artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
        artifact.object = args.object.config.delay;
        return (0, rxjs_1.of)(artifact)
            .pipe((0, operators_1.delay)(args.object.config.delay));
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('77cb1ef7-5485-4a5a-a524-eea284caccb6')
    ], EventIntervalHook.prototype, "interval", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('be1a3364-c325-4088-98b9-ff7ca6342ee1')
    ], EventIntervalHook.prototype, "delay", null);
    EventIntervalHook = __decorate([
        (0, nick_process_commons_1.HookClass)('event.interval')
    ], EventIntervalHook);
    return EventIntervalHook;
}());
exports.EventIntervalHook = EventIntervalHook;
//# sourceMappingURL=event.interval.hook.js.map