"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MailHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var rxjs_1 = require("rxjs");
var mailparser_1 = require("mailparser");
var MailHook = /** @class */ (function (_super) {
    __extends(MailHook, _super);
    function MailHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MailHook.prototype.parse = function (inputArtifact) {
        return new rxjs_1.Observable(function (observer) {
            (0, mailparser_1.simpleParser)(inputArtifact.object.source, inputArtifact.object.options, function (err, data) {
                if (err) {
                    observer.error(err);
                    observer.complete();
                    return;
                }
                var artifact = new nick_process_commons_1.NickProcessArtfact();
                artifact.object = data;
                artifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                observer.next(artifact);
                observer.complete();
            });
        });
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('b31f1c83-cf99-41b1-9516-9d08fe064041')
    ], MailHook.prototype, "parse", null);
    MailHook = __decorate([
        (0, nick_process_commons_1.HookClass)('mail')
    ], MailHook);
    return MailHook;
}(nick_process_commons_1.BaseHook));
exports.MailHook = MailHook;
//# sourceMappingURL=mail.hook.js.map