"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WebhookHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var operators_1 = require("rxjs/operators");
var http_hook_1 = require("../http/http.hook");
var WebhookHook = /** @class */ (function (_super) {
    __extends(WebhookHook, _super);
    function WebhookHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    WebhookHook.prototype.webhook = function (inputArtifact) {
        var _this = this;
        return this.make(http_hook_1.HttpHook)
            .pipe((0, operators_1.concatMap)(function (httpHook) {
            return _this.settings
                .pipe((0, operators_1.concatMap)(function (settings) {
                var endpoint = settings.environment == nick_data_commons_1.EnvironmentKind.DEV
                    ? 'https://webhook.local.nickbuilder.com.br/api/process/start/new/client/default'
                    : 'https://webhook.fluna.io/api/process/start/new/client/default';
                var httpArtifact = new nick_process_commons_1.NickProcessArtfact();
                httpArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
                httpArtifact.object = {
                    config: {
                        url: "".concat(endpoint, "/8460e2ee-1e5b-4a85-8533-064e8efba1cb"),
                        params: {},
                        headers: {
                            'nick-system': '925468af-4af9-4e78-b60d-8eb5cccd643d'
                        },
                        body: inputArtifact.object
                    }
                };
                return httpHook.postExternal(httpArtifact);
            }));
        }))
            .pipe((0, operators_1.map)(function (response) {
            return response;
        }));
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('6917a1a8-921f-4c9d-a542-a86892ebf414')
    ], WebhookHook.prototype, "webhook", null);
    WebhookHook = __decorate([
        (0, nick_process_commons_1.HookClass)('webhook')
    ], WebhookHook);
    return WebhookHook;
}(nick_process_commons_1.BaseHook));
exports.WebhookHook = WebhookHook;
//# sourceMappingURL=webhook.hook.js.map