import { BaseHook, NickProcessArtfact } from '@mrp-brasil/nick-process-commons';
import { Observable } from 'rxjs';
export declare class WorkflowHook extends BaseHook {
    getTaskByStep(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    createSubTask(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    updateTask(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    completeTasks(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    moveTask(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    prepareRunWorkflow(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    getTaskByParentTaskId(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    createAttachment(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    getTasksByParentExecutionId(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    createUpdateExecutionTags(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    downloadAttachment(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
}
//# sourceMappingURL=workflow.hook.d.ts.map