import { BaseHook, NickProcessArtfact } from '@mrp-brasil/nick-process-commons';
import { Observable } from 'rxjs';
export declare class AuthHook extends BaseHook {
    register(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    registerUserWithSystem(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    currentUser(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    isAuthenticate(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    changePassword(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    deleteUserSystemXref(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    activateUserSystemXref(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    changeRuleGroup(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    authenticate(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    authenticateBySystemId(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    createJWT(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    verifyJWT(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    decodeJWT(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    hashPassword(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    matchPassword(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    requestOTP(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    authenticateByOTP(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    countUsers(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    getUserListBySystem(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    registerParentUser(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    registerGroupUser(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    getGroupUser(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    validateRole(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    getUsersByRole(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    removeRoleFromUser(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    addRoleToUser(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    checkUserGroup(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    createMD5Hash(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    disableParentUser(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    getUsersByUserGroup(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    getRolesBySystem(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    getRole(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    currentUserBySystem(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    lockUser(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    unlockUser(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    getUserSystem(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    generateTokenToSystemUser(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
}
//# sourceMappingURL=auth.hook.d.ts.map