"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AwsCloudfrontHook = void 0;
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var aws = __importStar(require("aws-sdk"));
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var uuid_1 = require("uuid");
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var AwsCloudfrontHook = /** @class */ (function (_super) {
    __extends(AwsCloudfrontHook, _super);
    function AwsCloudfrontHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AwsCloudfrontHook.prototype.invalidate = function (inputArtifact) {
        return this.settings
            .pipe((0, operators_1.concatMap)(function (settings) {
            var cloudfront = new aws.CloudFront({
                region: 'us-east-1',
                apiVersion: '2020-05-31',
                credentials: { accessKeyId: settings.aws.accessKeyId, secretAccessKey: settings.aws.secretAccessKey }
            });
            var params = {
                DistributionId: 'EXGJJGTJGHJD8',
                InvalidationBatch: {
                    CallerReference: (0, uuid_1.v4)(),
                    Paths: {
                        Quantity: 1,
                        Items: [
                            "/*/".concat(inputArtifact.object.systemId, "/*")
                        ]
                    }
                }
            };
            return new rxjs_1.Observable(function (observer) {
                cloudfront.createInvalidation(params, function (err, data) {
                    if (err) {
                        var output = new nick_process_commons_1.NickProcessArtfact();
                        output.kind = nick_data_commons_1.ArtfactKind.ERROR;
                        output.object = err;
                        observer.error(output);
                    }
                    else {
                        var output = new nick_process_commons_1.NickProcessArtfact();
                        output.kind = nick_data_commons_1.ArtfactKind.ANY;
                        output.object = data;
                        observer.next(output);
                    }
                    observer.complete();
                });
            });
        }));
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('06ebe207-a8a1-435f-bfdd-361e2797f804')
    ], AwsCloudfrontHook.prototype, "invalidate", null);
    AwsCloudfrontHook = __decorate([
        (0, nick_process_commons_1.HookClass)('aws.cloudfront')
    ], AwsCloudfrontHook);
    return AwsCloudfrontHook;
}(nick_process_commons_1.BaseHook));
exports.AwsCloudfrontHook = AwsCloudfrontHook;
//# sourceMappingURL=aws.cloudfront.hook.js.map