import { BaseHook, NickProcessArtfact } from '@mrp-brasil/nick-process-commons';
import { Observable } from 'rxjs';
export declare class AwsS3Hook extends BaseHook {
    upload(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    delete(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    getUploadInfo(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    download(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    downloadToBuffer(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    downloadBase64(inputArtifact: NickProcessArtfact): any;
    downloadJson(inputArtifact: NickProcessArtfact): any;
    link(inputArtifact: NickProcessArtfact): any;
    private buildS3Bucket;
}
//# sourceMappingURL=aws.s3.hook.d.ts.map