import { BaseHook, NickProcessArtfact } from '@mrp-brasil/nick-process-commons';
import { Observable } from 'rxjs';
export declare class AwsSnsHook extends BaseHook {
    sendSms(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    sendEmail(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    registerDevice(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    sendPush(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    registerTopic(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    subscribeTopic(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    confirmTopicSubscription(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    publishTopicNotification(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
}
//# sourceMappingURL=aws.sns.hook.d.ts.map