"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.geradorLinhaDigitavel = void 0;
var formatacoesUtils_1 = require("../formatacoesUtils");
var gerador_de_digito_padrao_1 = require("./gerador-de-digito-padrao");
var valida_codigo_barras_1 = require("./valida-codigo-barras");
function geradorLinhaDigitavel(codigoDeBarras, banco) {
    (0, valida_codigo_barras_1.validarCodigoBarras)(codigoDeBarras);
    var linhaDigitavel = [];
    linhaDigitavel.push(codigoDeBarras.substring(0, 3));
    linhaDigitavel.push(codigoDeBarras.substring(3, 4));
    linhaDigitavel.push(codigoDeBarras.substring(19, 24));
    linhaDigitavel.push(gerador_de_digito_padrao_1.GeradorDeDigitoPadrao.mod10(linhaDigitavel.join('')));
    linhaDigitavel.push(codigoDeBarras.substring(24, 34));
    linhaDigitavel.push(gerador_de_digito_padrao_1.GeradorDeDigitoPadrao.mod10(linhaDigitavel.join('').substring(10, 20)));
    linhaDigitavel.push(codigoDeBarras.substring(34));
    linhaDigitavel.push(gerador_de_digito_padrao_1.GeradorDeDigitoPadrao.mod10(linhaDigitavel.join('').substring(21, 31)));
    linhaDigitavel.push(codigoDeBarras.substring(4, 5));
    linhaDigitavel.push(codigoDeBarras.substring(5, 9));
    linhaDigitavel.push(codigoDeBarras.substring(9, 19));
    return formatacoesUtils_1.FormatacoesUtils.linhaDigitavel(linhaDigitavel.join(''));
}
exports.geradorLinhaDigitavel = geradorLinhaDigitavel;
//# sourceMappingURL=gerador-de-linha-digitavel.js.map