"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.WritableBufferStream = void 0;
var stream_1 = require("stream");
var WritableBufferStream = /** @class */ (function (_super) {
    __extends(WritableBufferStream, _super);
    function WritableBufferStream(options) {
        var _this = _super.call(this, options) || this;
        _this._chunks = [];
        return _this;
    }
    WritableBufferStream.prototype._write = function (chunk, enc, callback) {
        this._chunks.push(chunk);
        return callback(null);
    };
    WritableBufferStream.prototype._destroy = function (err, callback) {
        this._chunks = null;
        return callback(null);
    };
    WritableBufferStream.prototype.toBuffer = function () {
        return Buffer.concat(this._chunks);
    };
    return WritableBufferStream;
}(stream_1.Stream.Writable));
exports.WritableBufferStream = WritableBufferStream;
//# sourceMappingURL=writeable.buffer.js.map