"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConditionHook = void 0;
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var ConditionHook = /** @class */ (function (_super) {
    __extends(ConditionHook, _super);
    function ConditionHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ConditionHook.prototype.conditionHook = function (inputArtifact) {
        return (0, rxjs_1.of)(nick_data_commons_1.NickCalculate.applyCondition(inputArtifact.object.valueA, inputArtifact.object.valueB, inputArtifact.object.conditionKind))
            .pipe((0, operators_1.map)(function (conditionResult) {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            outputArtifact.object = conditionResult;
            return outputArtifact;
        }));
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('427a8859-3ea5-4b62-8237-9329ab109639')
    ], ConditionHook.prototype, "conditionHook", null);
    ConditionHook = __decorate([
        (0, nick_process_commons_1.HookClass)('condition')
    ], ConditionHook);
    return ConditionHook;
}(nick_process_commons_1.BaseHook));
exports.ConditionHook = ConditionHook;
//# sourceMappingURL=condition.hook.js.map