"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ContextHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var operators_1 = require("rxjs/operators");
var ContextHook = /** @class */ (function (_super) {
    __extends(ContextHook, _super);
    function ContextHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ContextHook.prototype.currentSystem = function (inputArtifact) {
        return this.context.system
            .pipe((0, operators_1.map)(function (system) {
            var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
            outputArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            outputArtifact.object = system;
            return outputArtifact;
        }));
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('a31fabf2-1c2d-4f2f-b1e2-793a54d3bdfa')
    ], ContextHook.prototype, "currentSystem", null);
    ContextHook = __decorate([
        (0, nick_process_commons_1.HookClass)('context')
    ], ContextHook);
    return ContextHook;
}(nick_process_commons_1.BaseHook));
exports.ContextHook = ContextHook;
//# sourceMappingURL=context.hook.js.map