import { BaseHook, NickProcessArtfact } from '@mrp-brasil/nick-process-commons';
import { Observable } from 'rxjs';
export declare class DatabaseCassandraHook extends BaseHook {
    private static connections;
    private static connectionByModel;
    authenticate(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    query(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    sync(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    createTable(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    findRows(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    createOrUpdateRow(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
}
//# sourceMappingURL=database.cassandra.hook.d.ts.map