import { BaseHook, NickProcessArtfact } from '@mrp-brasil/nick-process-commons';
import { Observable } from 'rxjs';
export declare class DatabaseMongoHook extends BaseHook {
    private static connections;
    private static connectionByModel;
    authenticate(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    query(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    sync(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    createTable(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    findOne(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    find(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    findOneAndUpdateOLD(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    findOneAndUpdate(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    insertMany(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    findAndModify(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    deleteOne(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    deleteMany(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    findOneAndDelete(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
}
//# sourceMappingURL=database.mongo.hook.d.ts.map