"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NumberHook = void 0;
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var NumberHook = /** @class */ (function (_super) {
    __extends(NumberHook, _super);
    function NumberHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    NumberHook.prototype.increment = function (inputArtifact) {
        return (0, rxjs_1.from)(Object.keys(inputArtifact.object.data))
            .pipe((0, operators_1.map)(function (key) {
            ++inputArtifact.object.data[key];
        }), (0, operators_1.toArray)())
            .pipe((0, operators_1.concatMap)(function () {
            return (0, rxjs_1.of)(inputArtifact);
        }));
    };
    NumberHook.prototype.toFloat = function (inputArtifact) {
        return (0, rxjs_1.from)(Object.keys(inputArtifact.object.data))
            .pipe((0, operators_1.map)(function (key) {
            inputArtifact.object.data[key] = parseFloat(inputArtifact.object.data[key]).toFixed(inputArtifact.object.config.fractionDigits);
        }), (0, operators_1.toArray)())
            .pipe((0, operators_1.concatMap)(function () {
            return (0, rxjs_1.of)(inputArtifact);
        }));
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('42da9b37-689f-43b5-9847-204466337dbc')
    ], NumberHook.prototype, "increment", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('620bcaaf-2af0-4bf8-ac80-5a8ab7dcc436')
    ], NumberHook.prototype, "toFloat", null);
    NumberHook = __decorate([
        (0, nick_process_commons_1.HookClass)('number')
    ], NumberHook);
    return NumberHook;
}(nick_process_commons_1.BaseHook));
exports.NumberHook = NumberHook;
//# sourceMappingURL=number.hook.js.map