"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SoapHook = void 0;
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var soap_1 = require("soap");
var html_entities_1 = require("html-entities");
var SoapHook = /** @class */ (function (_super) {
    __extends(SoapHook, _super);
    function SoapHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SoapHook.prototype.soap = function (inputArtifact) {
        return (0, rxjs_1.from)((0, soap_1.createClientAsync)(inputArtifact.object.config.url))
            .pipe((0, operators_1.concatMap)(function (client) {
            return (0, rxjs_1.from)(client["".concat(inputArtifact.object.config.function, "Async")](inputArtifact.object.data));
        }))
            .pipe((0, operators_1.map)(function (result) {
            var _a, _b;
            var resultArtifact = new nick_process_commons_1.NickProcessArtfact();
            resultArtifact.kind = nick_data_commons_1.ArtfactKind.ANY;
            if (result) {
                var entities = new html_entities_1.AllHtmlEntities();
                if ((_a = inputArtifact.object.config) === null || _a === void 0 ? void 0 : _a.attr) {
                    var fields = inputArtifact.object.config.attr.split('.');
                    resultArtifact.object = fields.reduce(function (o, i) { return (o ? o[i] : o); }, result[0]);
                    if ((_b = inputArtifact.object.config) === null || _b === void 0 ? void 0 : _b.decode)
                        resultArtifact.object = JSON.parse(entities.decode(resultArtifact.object));
                    return resultArtifact;
                }
                resultArtifact.object = JSON.parse(entities.decode(result[0].return));
            }
            return resultArtifact;
        }));
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('c2b022fb-bef6-401b-8411-822af9c437bc')
    ], SoapHook.prototype, "soap", null);
    SoapHook = __decorate([
        (0, nick_process_commons_1.HookClass)('soap')
    ], SoapHook);
    return SoapHook;
}(nick_process_commons_1.BaseHook));
exports.SoapHook = SoapHook;
//# sourceMappingURL=soap.hook.js.map