import { BaseHook, NickProcessArtfact } from '@mrp-brasil/nick-process-commons';
import { Observable } from 'rxjs';
export declare class UserHook extends BaseHook {
    getUserDetailByUserId(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    getUserDetailByUserIdAndSystemId(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    getUserDetailByUsername(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    updateUserInfo(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    disableUser(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    enableUser(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    deleteUser(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    loadRuleGroup(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    changeUserRuleGroupId(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    changeUserPassword(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    createUpdateRuleGroup(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
    changeUserPasswordWithSystemId(inputArtifact: NickProcessArtfact): Observable<NickProcessArtfact>;
}
//# sourceMappingURL=user.hook.d.ts.map