"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UUIDHook = void 0;
var nick_data_commons_1 = require("@mrp-brasil/nick-data-commons");
var nick_process_commons_1 = require("@mrp-brasil/nick-process-commons");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var uuid_1 = require("uuid");
var UUIDHook = /** @class */ (function (_super) {
    __extends(UUIDHook, _super);
    function UUIDHook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UUIDHook.prototype.set = function (inputArtifact) {
        var fields = inputArtifact.object.map;
        return (0, rxjs_1.from)(fields)
            .pipe((0, operators_1.map)(function (field) { return inputArtifact.object.data[field] = (0, uuid_1.v4)(); }), (0, operators_1.toArray)())
            .pipe((0, operators_1.concatMap)(function () { return (0, rxjs_1.of)(inputArtifact); }));
    };
    UUIDHook.prototype.uuid = function (inputArtifact) {
        var outputArtifact = new nick_process_commons_1.NickProcessArtfact();
        outputArtifact.kind = nick_data_commons_1.ArtfactKind.ARRAY;
        outputArtifact.object = (0, uuid_1.v4)();
        return (0, rxjs_1.of)(outputArtifact);
    };
    UUIDHook.prototype.short = function (inputArtifact) {
        var fields = inputArtifact.object.fields;
        return (0, rxjs_1.from)(fields)
            .pipe((0, operators_1.map)(function (field) { return inputArtifact.object.data[field] = (0, uuid_1.v4)().split('-')[0].toUpperCase(); }), (0, operators_1.toArray)())
            .pipe((0, operators_1.concatMap)(function () { return (0, rxjs_1.of)(inputArtifact); }));
    };
    __decorate([
        (0, nick_process_commons_1.Hook)('b50e5769-172e-4611-b348-9f36d4e98a04')
    ], UUIDHook.prototype, "set", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('31e2bd19-5887-4335-ac2c-712520d90149')
    ], UUIDHook.prototype, "uuid", null);
    __decorate([
        (0, nick_process_commons_1.Hook)('d6b3a675-a4f1-448b-948b-dc8aa973ba06')
    ], UUIDHook.prototype, "short", null);
    UUIDHook = __decorate([
        (0, nick_process_commons_1.HookClass)('uuid')
    ], UUIDHook);
    return UUIDHook;
}(nick_process_commons_1.BaseHook));
exports.UUIDHook = UUIDHook;
//# sourceMappingURL=uuid.hook.js.map